> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.getunleash.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getunleash.io/_mcp/server.

# Post Bulk Metrics

POST https://edge.unleash-instance.example.com/api/client/metrics/bulk
Content-Type: application/json

Reference: https://docs.getunleash.io/api/post-bulk-metrics

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: edge-api
  version: 1.0.0
paths:
  /api/client/metrics/bulk:
    post:
      operationId: post-bulk-metrics
      summary: Post Bulk Metrics
      tags:
        - subpackage_clientApi
      parameters:
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
      responses:
        '202':
          description: Accepted bulk metrics
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Client API_post_bulk_metrics_Response_202'
        '403':
          description: Was not allowed to post bulk metrics
          content:
            application/json:
              schema:
                description: Any type
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BatchMetricsRequestBody'
servers:
  - url: https://edge.unleash-instance.example.com
    description: Your Unleash Edge instance (replace with your actual URL)
components:
  schemas:
    SdkType:
      type: string
      enum:
        - frontend
        - backend
      title: SdkType
    ConnectVia:
      type: object
      properties:
        appName:
          type: string
        instanceId:
          type: string
      required:
        - appName
        - instanceId
      title: ConnectVia
    ClientApplication:
      type: object
      properties:
        platformName:
          type:
            - string
            - 'null'
        platformVersion:
          type:
            - string
            - 'null'
        sdkType:
          oneOf:
            - $ref: '#/components/schemas/SdkType'
            - type: 'null'
        sdkVersion:
          type:
            - string
            - 'null'
        yggdrasilVersion:
          type:
            - string
            - 'null'
        appName:
          type: string
        connectVia:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/ConnectVia'
        connectionId:
          type:
            - string
            - 'null'
        environment:
          type:
            - string
            - 'null'
        instanceId:
          type:
            - string
            - 'null'
        interval:
          type: integer
        projects:
          type:
            - array
            - 'null'
          items:
            type: string
        started:
          type: string
          format: date-time
        strategies:
          type: array
          items:
            type: string
      required:
        - appName
        - interval
        - started
        - strategies
      title: ClientApplication
    BTreeMap:
      type: object
      additionalProperties:
        type: string
      title: BTreeMap
    NumericMetricSample:
      type: object
      properties:
        labels:
          oneOf:
            - $ref: '#/components/schemas/BTreeMap'
            - type: 'null'
        value:
          type: number
          format: double
      required:
        - value
      title: NumericMetricSample
    ImpactMetricOneOf0Type:
      type: string
      enum:
        - counter
      title: ImpactMetricOneOf0Type
    ImpactMetric0:
      type: object
      properties:
        help:
          type: string
        name:
          type: string
        samples:
          type: array
          items:
            $ref: '#/components/schemas/NumericMetricSample'
        type:
          $ref: '#/components/schemas/ImpactMetricOneOf0Type'
      required:
        - help
        - name
        - samples
        - type
      title: ImpactMetric0
    ImpactMetricOneOf1Type:
      type: string
      enum:
        - gauge
      title: ImpactMetricOneOf1Type
    ImpactMetric1:
      type: object
      properties:
        help:
          type: string
        name:
          type: string
        samples:
          type: array
          items:
            $ref: '#/components/schemas/NumericMetricSample'
        type:
          $ref: '#/components/schemas/ImpactMetricOneOf1Type'
      required:
        - help
        - name
        - samples
        - type
      title: ImpactMetric1
    Bucket:
      type: object
      properties:
        count:
          type: integer
          format: int64
        le:
          type: number
          format: double
      required:
        - count
        - le
      title: Bucket
    BucketMetricSample:
      type: object
      properties:
        buckets:
          type: array
          items:
            $ref: '#/components/schemas/Bucket'
        count:
          type: integer
          format: int64
        labels:
          oneOf:
            - $ref: '#/components/schemas/BTreeMap'
            - type: 'null'
        sum:
          type: number
          format: double
      required:
        - buckets
        - count
        - sum
      title: BucketMetricSample
    ImpactMetricOneOf2Type:
      type: string
      enum:
        - histogram
      title: ImpactMetricOneOf2Type
    ImpactMetric2:
      type: object
      properties:
        help:
          type: string
        name:
          type: string
        samples:
          type: array
          items:
            $ref: '#/components/schemas/BucketMetricSample'
        type:
          $ref: '#/components/schemas/ImpactMetricOneOf2Type'
      required:
        - help
        - name
        - samples
        - type
      title: ImpactMetric2
    ImpactMetric:
      oneOf:
        - $ref: '#/components/schemas/ImpactMetric0'
        - $ref: '#/components/schemas/ImpactMetric1'
        - $ref: '#/components/schemas/ImpactMetric2'
      title: ImpactMetric
    ClientMetricsEnv:
      type: object
      properties:
        platformName:
          type:
            - string
            - 'null'
        platformVersion:
          type:
            - string
            - 'null'
        sdkType:
          oneOf:
            - $ref: '#/components/schemas/SdkType'
            - type: 'null'
        sdkVersion:
          type:
            - string
            - 'null'
        yggdrasilVersion:
          type:
            - string
            - 'null'
        appName:
          type: string
        environment:
          type: string
        featureName:
          type: string
        'no':
          type: integer
        timestamp:
          type: string
          format: date-time
        variants:
          type: object
          additionalProperties:
            type: integer
        'yes':
          type: integer
      required:
        - appName
        - environment
        - featureName
        - 'no'
        - timestamp
        - variants
        - 'yes'
      title: ClientMetricsEnv
    BatchMetricsRequestBody:
      type: object
      properties:
        applications:
          type: array
          items:
            $ref: '#/components/schemas/ClientApplication'
        impactMetrics:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/ImpactMetric'
        metrics:
          type: array
          items:
            $ref: '#/components/schemas/ClientMetricsEnv'
      required:
        - applications
        - metrics
      title: BatchMetricsRequestBody
    Client API_post_bulk_metrics_Response_202:
      type: object
      properties: {}
      description: Empty response body
      title: Client API_post_bulk_metrics_Response_202
  securitySchemes:
    Authorization:
      type: apiKey
      in: header
      name: Authorization

```

## Examples



**Request**

```json
{
  "applications": [
    {
      "appName": "inventory-service",
      "interval": 60,
      "started": "2024-01-15T09:30:00Z",
      "strategies": [
        "default",
        "userWithId"
      ]
    }
  ],
  "metrics": [
    {
      "appName": "inventory-service",
      "environment": "production",
      "featureName": "new-checkout-flow",
      "no": 120,
      "timestamp": "2024-01-15T09:30:00Z",
      "variants": {},
      "yes": 300
    }
  ]
}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://edge.unleash-instance.example.com/api/client/metrics/bulk"

payload = {
    "applications": [
        {
            "appName": "inventory-service",
            "interval": 60,
            "started": "2024-01-15T09:30:00Z",
            "strategies": ["default", "userWithId"]
        }
    ],
    "metrics": [
        {
            "appName": "inventory-service",
            "environment": "production",
            "featureName": "new-checkout-flow",
            "no": 120,
            "timestamp": "2024-01-15T09:30:00Z",
            "variants": {},
            "yes": 300
        }
    ]
}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://edge.unleash-instance.example.com/api/client/metrics/bulk';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"applications":[{"appName":"inventory-service","interval":60,"started":"2024-01-15T09:30:00Z","strategies":["default","userWithId"]}],"metrics":[{"appName":"inventory-service","environment":"production","featureName":"new-checkout-flow","no":120,"timestamp":"2024-01-15T09:30:00Z","variants":{},"yes":300}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://edge.unleash-instance.example.com/api/client/metrics/bulk"

	payload := strings.NewReader("{\n  \"applications\": [\n    {\n      \"appName\": \"inventory-service\",\n      \"interval\": 60,\n      \"started\": \"2024-01-15T09:30:00Z\",\n      \"strategies\": [\n        \"default\",\n        \"userWithId\"\n      ]\n    }\n  ],\n  \"metrics\": [\n    {\n      \"appName\": \"inventory-service\",\n      \"environment\": \"production\",\n      \"featureName\": \"new-checkout-flow\",\n      \"no\": 120,\n      \"timestamp\": \"2024-01-15T09:30:00Z\",\n      \"variants\": {},\n      \"yes\": 300\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://edge.unleash-instance.example.com/api/client/metrics/bulk")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"applications\": [\n    {\n      \"appName\": \"inventory-service\",\n      \"interval\": 60,\n      \"started\": \"2024-01-15T09:30:00Z\",\n      \"strategies\": [\n        \"default\",\n        \"userWithId\"\n      ]\n    }\n  ],\n  \"metrics\": [\n    {\n      \"appName\": \"inventory-service\",\n      \"environment\": \"production\",\n      \"featureName\": \"new-checkout-flow\",\n      \"no\": 120,\n      \"timestamp\": \"2024-01-15T09:30:00Z\",\n      \"variants\": {},\n      \"yes\": 300\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://edge.unleash-instance.example.com/api/client/metrics/bulk")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"applications\": [\n    {\n      \"appName\": \"inventory-service\",\n      \"interval\": 60,\n      \"started\": \"2024-01-15T09:30:00Z\",\n      \"strategies\": [\n        \"default\",\n        \"userWithId\"\n      ]\n    }\n  ],\n  \"metrics\": [\n    {\n      \"appName\": \"inventory-service\",\n      \"environment\": \"production\",\n      \"featureName\": \"new-checkout-flow\",\n      \"no\": 120,\n      \"timestamp\": \"2024-01-15T09:30:00Z\",\n      \"variants\": {},\n      \"yes\": 300\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://edge.unleash-instance.example.com/api/client/metrics/bulk', [
  'body' => '{
  "applications": [
    {
      "appName": "inventory-service",
      "interval": 60,
      "started": "2024-01-15T09:30:00Z",
      "strategies": [
        "default",
        "userWithId"
      ]
    }
  ],
  "metrics": [
    {
      "appName": "inventory-service",
      "environment": "production",
      "featureName": "new-checkout-flow",
      "no": 120,
      "timestamp": "2024-01-15T09:30:00Z",
      "variants": {},
      "yes": 300
    }
  ]
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://edge.unleash-instance.example.com/api/client/metrics/bulk");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"applications\": [\n    {\n      \"appName\": \"inventory-service\",\n      \"interval\": 60,\n      \"started\": \"2024-01-15T09:30:00Z\",\n      \"strategies\": [\n        \"default\",\n        \"userWithId\"\n      ]\n    }\n  ],\n  \"metrics\": [\n    {\n      \"appName\": \"inventory-service\",\n      \"environment\": \"production\",\n      \"featureName\": \"new-checkout-flow\",\n      \"no\": 120,\n      \"timestamp\": \"2024-01-15T09:30:00Z\",\n      \"variants\": {},\n      \"yes\": 300\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "applications": [
    [
      "appName": "inventory-service",
      "interval": 60,
      "started": "2024-01-15T09:30:00Z",
      "strategies": ["default", "userWithId"]
    ]
  ],
  "metrics": [
    [
      "appName": "inventory-service",
      "environment": "production",
      "featureName": "new-checkout-flow",
      "no": 120,
      "timestamp": "2024-01-15T09:30:00Z",
      "variants": [],
      "yes": 300
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://edge.unleash-instance.example.com/api/client/metrics/bulk")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```